Author Topic: Read and parse .csv or .txt file  (Read 876 times)

0 Members and 1 Guest are viewing this topic.

Offline fixo

  • Full Member
  • ***
  • Posts: 135
  • Karma: +4/-0
  • Gender: Male
    • prefered language: C
    • Prog expertise: Good
    • View Profile
Read and parse .csv or .txt file
« on: December 29, 2012, 08:16:31 PM »
 
Code: [Select]
       [CommandMethod("ptsRead")]
        public void testReadCSV()
        {   // file name contains separated text
            string filePath = @"C:\Test\points.txt";
            if (!File.Exists(filePath))
            {
                MessageBox.Show("File does not exist");
                return;
            }
            // put appropriate delimiter here
            string sep = ";";
            Point3dCollection pts = new Point3dCollection();
            using (System.IO.StreamReader reader = new System.IO.StreamReader(filePath))
            {
                while (!reader.EndOfStream)
                {
                    // Call reader.ReadLine() appropriately
                    string textLine = reader.ReadLine();
                    Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor.WriteMessage("\n{0}", textLine);
                    string[] tmp = textLine.Split(new string[] { sep }, StringSplitOptions.RemoveEmptyEntries);
                    if (tmp.Length != 0)
                    {
                        Point3d pt = new Point3d(Convert.ToDouble(tmp[0]), Convert.ToDouble(tmp[1]), Convert.ToDouble(tmp[2]));
                        pts.Add(pt);
                    }
                }
            }

            if (pts == null)
            {
                MessageBox.Show("Cant parse this file");
                return;
            }
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;

            Database db = doc.Database;

            Editor ed = doc.Editor;

            Autodesk.AutoCAD.ApplicationServices.Application.SetSystemVariable("pdmode", 34);

            Autodesk.AutoCAD.ApplicationServices.Application.SetSystemVariable("pdsize", 2.0);

            using (Transaction tr = db.TransactionManager.StartTransaction())
            {
                BlockTableRecord btr = tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite) as BlockTableRecord;

                foreach (Point3d pnt in pts)
                {
                    DBPoint pt = new DBPoint(pnt);

                    pt.SetDatabaseDefaults();

                    pt.ColorIndex = 1;// <-- set any color of point

                    btr.AppendEntity(pt);

                    DBText txt = new DBText();

                    tr.AddNewlyCreatedDBObject(pt, true);

                    txt.SetDatabaseDefaults();

                    txt.Position = pt.Position;

                    txt.TextString = txt.Position.ToString();//<-- add any textstring to suit

                    txt.Justify = AttachmentPoint.BaseLeft;

                    // txt.AlignmentPoint = pt.Position;

                    txt.AdjustAlignment(db);

                    btr.AppendEntity(txt);

                    tr.AddNewlyCreatedDBObject(txt, true);
                }
                tr.Commit();
            }
        }